#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_event_snooze.pl
# !*-------------------------------------------------------------------------

$P = "dbamon_event_snooze.pl";
use DBI;
use Time::Local;

require "cgi_handlers.pl";

$debug = 1; 

#---- Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;
$f_s = "<font size=2 face=$font>";

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

$fs = "<font size=2>";
#$fe = "</font>";

chop($hostname = `hostname`);

$data_source = "dbi:mysql";
$database = "dbamon";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

$dbms = "mysql";

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  ##print "</center><br><font size=2>$date ${P} | <b>$msgmsg</b></font><center>\n";
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#------------------------------------------------------------------------------
sub msgText
#------------------------------------------------------------------------------
{
  my $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "${P} | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $emsg = $_[0];
  &msg("Fatal Error: $emsg");
  &msg("Last SQL: $sql");
  exit 1; 
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
  local($errorMsg) = @_;

  #print "Content-type: text/html\n\n";
  print "<head><title> Database Function Error - Output</title></head>";
  print "<body>";

  print "<h3> The following database error occured - $date<hr></h3>";
  print "</hr noshade>";
  print "<h4> $errorMsg $DBI::errstr</h4>";
  print "SQL Statement: <pre>$sql</pre>";

  &PrintLinks;

  print "</body>";
  print "</html>";

  $emsg = $_[0];
  $sqlerror = $DBI::errstr;
  print "==========================================\n";
  print "Fatal Error: $emsg - $sqlerror\n";
  print "==========================================\n";
  chop($admin_email = `grep Admin_EMail: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
  system("echo \"$P - DBAmon Master Server: $hostname\" | mailx -s \"DBAmon Fatal Error: $P - $emsg - $sqlerror\" $admin_email");

  exit(1);
}

#------------------------------------------------------------------------------
sub timeToNum
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  ##print "zz_text=$zz_text\n";
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("Input Target_End_Time ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS","DOC116");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("Input Target_End_Time - YYYY must be 2002-2099","DOC116") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("Input Target_End_Time - MON  must be 1-12     ","DOC116") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("Input Target_End_Time - DD   must be 1-31     ","DOC116") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("Input Target_End_Time - HH   must be 0-23     ","DOC116") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("Input Target_End_Time - MM   must be 0-59     ","DOC116") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("Input Target_End_Time - SS   must be 0-59     ","DOC116") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  return $zz_result;
}

#-----------------------------------------------------------------------------
sub error_check
#-----------------------------------------------------------------------------
{
  if ($rqpairs{'reason'} eq "")
  {
     push (@error_list, "Reason must not be blank\n");
  }

  if ($rqpairs{'user'} eq "")
  {
     push (@error_list, "Your initials must not be blank\n");
  }

  if (length($rqpairs{'user'}) < 2)
  {
     push (@error_list, "Your initials must be 2 characters in length\n");
  }

  #---- Check time range
  $sts_num = &timeToNum("$rqpairs{'s_yyyy'}/$rqpairs{'s_mm'}/$rqpairs{'s_dd'}-$rqpairs{'s_hh'}:$rqpairs{'s_min'}:00");
  $ets_num = &timeToNum("$rqpairs{'e_yyyy'}/$rqpairs{'e_mm'}/$rqpairs{'e_dd'}-$rqpairs{'e_hh'}:$rqpairs{'e_min'}:00");
  $ts_diff_secs = $ets_num - $sts_num;
  $ts_diff_days = int($ts_diff_secs / (24*60*60));
  &msg("Calculations - sts_num=$sts_num ets_num=$ets_num ts_diff_secs=$ts_diff_secs ts_diff_days=$ts_diff_days");  
  push (@error_list, "Snooze period end timestamp must be greater than start timestamp\n") if $ts_diff_secs <= 0;
  push (@error_list, "Snooze period (you specified $ts_diff_days days) must not exceed 30 days\n") if $ts_diff_days > 30;

  $sts = $rqpairs{'s_yyyy'} . $rqpairs{'s_mm'} .$rqpairs{'s_dd'} .$rqpairs{'s_hh'} .$rqpairs{'s_min'} . "00";
  $ets = $rqpairs{'e_yyyy'} . $rqpairs{'e_mm'} .$rqpairs{'e_dd'} .$rqpairs{'e_hh'} .$rqpairs{'e_min'} . "00";
  if ($sts eq "00" || $ets eq "00")
  {
    push (@error_list, "Both timestamp values must not be blank\n");
  }
  if (length($sts) != 14 || length($ets) != 14)
  {
    push (@error_list, "Timestamp values must be filled in completely\n");
  }
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  local($Signal) = @_;
  ##close(you_fill_in_the_file_descriptor);
  ##unlink($you_fill_in_the_tmp_file_name);
  &msg("Signal=$Signal received");
  exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $html_str=$str.$str1.$str1;
   print "$html_str\n";
   print "<h4>Input Error(s) Encountered - Please correct the following:</h4>";
   print "<p>\n";
   print "<ul>\n";
   foreach( @error_list) 
   {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors correction(s) to make.<p>\n";
   }
   print "<hr>Click <b>BACK</b> and try again.\n";
      
}

#-----------------------------------------------------------------------------
sub create_form 
#-----------------------------------------------------------------------------
{
  ##print "<h3>Instance: <font color=blue> $instance </font><hr></h3>\n";
  print "<FORM method='POST' action='/cgi-bin/dbamon_event_snooze.pl'>";
  print "<p> <FORM> 
  <TABLE>

  <tr>
  <span $style_normal>
  <Td ALIGN=RIGHT><B>$fs Event Snooze Period Start Time:<BR></b>
  </B><FONT SIZE=1>(Format: YYYY/MM/DD-HH:MM)
  <TD>
  <INPUT type=text size=4 maxlength=4 name=s_yyyy value=$s_yyyy> /
  <INPUT type=text size=2 maxlength=2 name=s_mm   value=$s_mm>/
  <INPUT type=text size=2 maxlength=2 name=s_dd   value=$s_dd> -
  <INPUT type=text size=2 maxlength=2 name=s_hh   value=$s_hh>:
  <INPUT type=text size=2 maxlength=2 name=s_min  value=$s_min> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Event Snooze Period End Time:<BR>
  </B><FONT SIZE=1>(Format: YYYY/MM/DD-HH:MM)
  <TD>
  <INPUT type=text size=4 maxlength=4 name=e_yyyy value=$e_yyyy> /
  <INPUT type=text size=2 maxlength=2 name=e_mm   value=$e_mm>/
  <INPUT type=text size=2 maxlength=2 name=e_dd   value=$e_dd> -
  <INPUT type=text size=2 maxlength=2 name=e_hh   value=$e_hh>:
  <INPUT type=text size=2 maxlength=2 name=e_min  value=$e_min> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Your Initials:<BR>
  </B><FONT SIZE=1>(Your Initials - Example: ab)
  <TD>
  <INPUT type=text size=2 maxlength=2 name=user value=\"$user\"> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Reason For Snooze:<BR>
  </B><FONT SIZE=1>(Format: Text)</FONT></TH>
  <TD>
  <INPUT type=text size=60 maxlength=60 name=reason value=\"$reason\"> 

  <tr>
  <Td ALIGN=RIGHT><B>$fs Action:</b><BR><FONT SIZE=1>(Click One)
  <TD>    <INPUT name=opcode type=radio value=insert CHECKED><b>$fs Insert This Data (After First Deleting any Snooze Data for This Event on this Instance)</b>
      <br><INPUT name=opcode type=radio value=delete        ><b>$fs Delete Any Snooze Data For This Event on this Instance</b>
  \n";

  print "</table> </b> <HR>
  &nbsp; <b><INPUT type=submit value=\"Save Changes\"></input></b>
  <hr>
  <INPUT TYPE=HIDDEN NAME=form_instance value=\"$in_instance\">
  <INPUT TYPE=HIDDEN NAME=form_event value=\"$in_event\">
  </form>
  <!--#include virtual=\"/solutions/dba/misc/foot.html\"-->
  ";
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error('Failed_on_DB_connect_in_updateDb');
}

#----------------------------------------------------------
sub checkDBAmonDBC
#----------------------------------------------------------
{
  my $dbc_server   = $_[0];
  my $dbc_instance = $_[1];

  my $dbc_server_first = (split(/\./,$dbc_server)) [0];

  &msg("    Looking for DBAmon DBC file for $dbc_server_first/$dbc_instance (dbc_server=$dbc_server)");

  $sql = "select
    dbc_filename 
  from 
    dbamon.dbc 
  where 
    dbc_parm = 'Host:' 
    and dbc_value like '${dbc_server_first}%'";
  ##print "sql=$sql\n";

  $sth = $dbh->prepare($sql) || &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  while (@Data = $sth->fetchrow_array)
  {
    $dbc_file   = $Data[0];
  }
  ##print "dbc_file=$dbc_file\n";

  $sql = "select distinct
    dbc_parm,
    dbc_value
  from 
    dbamon.dbc 
  where 
    dbc_filename = '$dbc_file' 
    and dbc_dbamonmode = 'prod' ";
  ##print "sql=$sql\n";

  $sth = $dbh->prepare($sql) || &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  while (@Data = $sth->fetchrow_array)
  {
    $dbc_parm   = $Data[0];
    $dbc_value  = $Data[1];

    $dbc_parm =~ s/://g;

    ##print "dbc_parm=$dbc_parm dbc_value=$dbc_value\n";

    if ($dbc_parm eq "OraApps_FS_Check") 
    {
      $cmd = "\$dbc_${dbc_parm} .= \"$dbc_value \"";
    }
    else
    {
      $cmd = "\$dbc_${dbc_parm} = \"$dbc_value\"";
    }
    ##print "cmd=$cmd \n";
    eval("$cmd");
  }
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  #---- Create the SQL SELECT statement
  $sql  = "select es_ts, es_instance, es_event, es_sts, es_ets, es_reason, es_zuser from dbamon.event_snooze where es_instance = '$in_instance'";
  &msg("DEBUG:sql=$sql") if $debug; 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
 
  $user = "";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts     = $Data[0];
    $zinstance = $Data[1]; 
    $zevent    = $Data[2]; 
    $sts    = $Data[3];
    $ets    = $Data[4];
    $reason = $Data[5];
    $user   = $Data[6];
    $selectcount++;
  }

  $s_yyyy = substr($sts,0,4);
  $s_mm   = substr($sts,4,2);
  $s_dd   = substr($sts,6,2);
  $s_hh   = substr($sts,8,2);
  $s_min  = substr($sts,10,2);

  $e_yyyy = substr($ets,0,4);
  $e_mm   = substr($ets,4,2);
  $e_dd   = substr($ets,6,2);
  $e_hh   = substr($ets,8,2);
  $e_min  = substr($ets,10,2);

  $reason =~ s/"/'/g;
  ##$previous_values = "Starttime=$sts Endtime=$ets Reason=$reason User=$user Created=$ts";
  print "<p><b>Previous Event Snooze values for this Instance and Event (if any):</b>
  <table border=1 bgcolor=lightblue>
  <tr bgcolor=slate>
    <th>$f_s Instance
    <th>$f_s Event
    <th>$f_s Snooze Start
    <th>$f_s Snooze End
    <th>$f_s Reason
    <th>$f_s User
    <th>$f_s Date Created
  <tr bgcolor=wheat>
    <td>$f_s $zinstance
    <td>$f_s $zevent
    <td>$f_s $sts
    <td>$f_s $ets
    <td>$f_s $reason
    <td>$f_s $user
    <td>$f_s $ts
  </table><p><hr>";
}

#-----------------------------------------------------------------------------
sub selectDataAllEvents
#-----------------------------------------------------------------------------
{
  #---- Create the SQL SELECT statement
  $sql  = "select 
    es_ts, 
    es_instance, 
    es_event, 
    es_sts, 
    es_ets, 
    es_reason, 
    es_zuser,
    datediff(mi, es_sts, getdate()),
    datediff(mi, es_ets, getdate()) 
  from dbamon.event_snooze where es_instance = '$in_instance' order by 2,3";
  &msg("DEBUG:sql=$sql") if $debug; 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
 
  $user = "";

  print "<p><b>Previous Event Snooze values for this Instance (if any):</b>
  <table border=0 bgcolor=lightblue>
  <tr bgcolor=slate>
    <th>$f_s Instance/Event<br>Click to Edit/Delete
    <th>$f_s Snooze Start
    <th>$f_s Snooze End
    <th>$f_s Reason
    <th>$f_s User
    <th>$f_s Date Created
    <th>$f_s Is This Snooze<br>In Effect Now? 
  "; 

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts     = $Data[0];
    $zinstance = $Data[1]; 
    $zevent    = $Data[2]; 
    $sts    = $Data[3];
    $ets    = $Data[4];
    $reason = $Data[5];
    $user   = $Data[6];
    $datediff_sts   = $Data[7];
    $datediff_ets   = $Data[8];

    $selectcount++;

    if ($datediff_sts > 0 && $datediff_ets < 0) 
    {
      $zcolor = "lime";   
      $zstat  = "Yes"; 
    }
    else
    {
      $zcolor = "white";   
      $zstat  = "No"; 
    }

    $s_yyyy = substr($sts,0,4);
    $s_mm   = substr($sts,4,2);
    $s_dd   = substr($sts,6,2);
    $s_hh   = substr($sts,8,2);
    $s_min  = substr($sts,10,2);

    $e_yyyy = substr($ets,0,4);
    $e_mm   = substr($ets,4,2);
    $e_dd   = substr($ets,6,2);
    $e_hh   = substr($ets,8,2);
    $e_min  = substr($ets,10,2);

    $reason =~ s/"/'/g;
    ##$previous_values = "Starttime=$sts Endtime=$ets Reason=$reason User=$user Created=$ts";
    print "
    <tr bgcolor=wheat>
      <td>$f_s &nbsp; <a href='/cgi-bin/$P?,$zinstance,$zevent'><b>$zinstance / $zevent</b></a> &nbsp; 
      <td>$f_s $sts
      <td>$f_s $ets
      <td>$f_s $reason
      <td>$f_s $user
      <td>$f_s $ts
      <td bgcolor=$zcolor>$f_s $zstat ($datediff_sts, $datediff_ets)
    "; 
  }

  print "
  </table><p><hr>";
}

#-----------------------------------------------------------------------------
sub init_values 
#-----------------------------------------------------------------------------
{
  chop($dateraw = `date +%Y%m%d%H%M%S`);

  $yyyy = substr($dateraw,0,4);
  $mm   = substr($dateraw,4,2);
  $dd   = substr($dateraw,6,2);
  $hour = substr($dateraw,8,2);
  $min  = substr($dateraw,10,2);

  $s_yyyy = $yyyy;
  $s_mm   = $mm;
  $s_dd   = $dd;
  $s_hh   = $hour;
  $s_min  = $min;

  $e_yyyy = $yyyy;
  $e_mm   = $mm;
  $e_dd   = $dd;
  $e_hh   = 23;
  $e_min  = 59;

  $reason = "";
  $user   = "";
}


#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{
   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#
# Attempt to make sure that no meta characters are entered in the form.
#
#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
sub deleteData
#-----------------------------------------------------------------------------
{
  &msg("deleteData - Starting") if $debug;
  $sql  = "delete from dbamon.event_snooze where es_instance = '$form_instance' and es_event = '$form_event'";
  $rc = $dbh->do($sql) || &error('Failed_on_DB_do_delete');
  &msg("Deleted all previous EVENT_SNOOZE rows - Where es_instance='$form_instance' and es_event='$form_event'"); 

  &msg("deleteData - Done") if $debug;
}

#-----------------------------------------------------------------------------
sub insertData
#-----------------------------------------------------------------------------
{
  $reason   = $rqpairs{'reason'};
  $user     = $rqpairs{'user'};

  #---- Remove naughty characters
  $reason   =~ s/'/"/g;
  $instance =~ s/'/"/g;

  $sts_ref = substr($sts,0,4) . '-' . substr($sts,4,2) . '-' . substr($sts,6,2) . ' ' . substr($sts,8,2) . ':' . substr($sts,10,2) . ':' . substr($sts,12,2);
  $ets_ref = substr($ets,0,4) . '-' . substr($ets,4,2) . '-' . substr($ets,6,2) . ' ' . substr($ets,8,2) . ':' . substr($ets,10,2) . ':' . substr($ets,12,2);
  $sql  = "insert into 
  dbamon.event_snooze 
    (es_instance, es_event, es_reason, es_zuser, es_sts, es_ets) 
  values 
    ('$form_instance', 
     '$form_event', 
     '$reason',
     '$user',
     '$sts_ref',
     '$ets_ref'
    )
  ";
  &msg("sql=($sql)") if $debug;
  $rc = $dbh->do($sql) || &error('Failed_on_DB_do_insert');

  &msg("The following data has been successfully inserted:<ul>");
  print "<li>Instance: <b> $form_instance</b>\n";
  print "<li>Event: <b> $form_event</b>\n";
  print "<li>Reason:  <b>$reason</b>\n";
  print "<li>User:   <b>$user</b>\n";
  print "<li>Start Timestamp:  <b>$sts</b>\n";
  print "<li>End Timestamp:  <b>$ets</b>\n";
  print "</ul>\n";
}

#----------------------------------------------------------
sub checkBA
#----------------------------------------------------------
{
  print "$P | Checking DBAMON.BA_INHIBIT for backup age checking inhibit now\n";
  $bai_statement  = "select 
    to_char(sts,\'YYYY/MM/DD-HH24:MI:SS\'), 
    to_char(ets,\'YYYY/MM/DD-HH24:MI:SS\'), 
    to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\'), 
    zuser, 
    reason 
  from dbamon.event_snooze 
  where 
    instance = '$in_hostname:$in_instance'
    and sysdate >= sts and sysdate <= ets";

  ##print "bai_statement=$bai_statement\n";

  $sth = $dbh->prepare($bai_statement) ||
          &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  $bai_selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $bai_sts    = $Data[0];
    $bai_ets    = $Data[1];
    $bai_ts     = $Data[2];
    $bai_user   = $Data[3];
    $bai_reason = $Data[4];
    $bai_selectcount++;
  }

  $bai_user =~ s/ //g;
  print "$P | bai_selectcount=$bai_selectcount\n";  

  if ($bai_selectcount > 0)
  {
    print "$P | BA_INHIBITED\n";
    print "$P | bai_sts=$bai_sts bai_ets=$bai_ets bai_ts=$bai_ts bai_user=$bai_user\n";  
    print "$P | bai_reason=$bai_reason\n";  
  }
}

#----------------------------------------------------------
sub scpDelete
#----------------------------------------------------------
{
  &msg("Deleting Backup Inhibit settings from $in_hostname");
  ##$cmd = "remsh $hostname -l dbamon 'ssh -l $dbc_Userid $in_hostname rm /tmp/dbamon_ba_inhibit_$in_instance.txt'";
  $cmd = "remsh $hostname -l dbamon 'ssh -l $dbc_Userid $dbc_Host rm /tmp/dbamon_ba_inhibit_$in_instance.txt'";
  &msg("Running cmd=$cmd");
  $rc = system("$cmd 2>&1");
  if ($rc != 0)
  {
    &error("Error rc=$rc ssh-ing - cmd=$cmd"); 
  }
}

#----------------------------------------------------------
sub scpFile
#----------------------------------------------------------
{
  &msg("scp-ing Backup Inhibit settings to $in_hostname");
  $tmpfile = "/tmp/dbamon_ba_inhibit_$$.txt";
  open(TMP, ">$tmpfile");
  print TMP "$sts $ets $user $reason\n";
  close(TMP);

  ##print "<pre>";
  ##system("cat $tmpfile");
  ##print "</pre>";

  ##$cmd = "remsh $hostname -l dbamon 'scp $tmpfile $dbc_Userid\@$in_hostname:/tmp/dbamon_ba_inhibit_$in_instance.txt'";
  $cmd = "remsh $hostname -l dbamon 'scp $tmpfile $dbc_Userid\@$dbc_Host:/tmp/dbamon_ba_inhibit_$in_instance.txt'";
  &msg("Running cmd=$cmd");
  $rc = system("$cmd 2>&1");
  if ($rc != 0)
  {
    &error("Error rc=$rc scp-ing - cmd=$cmd"); 
  }
  system("rm $tmpfile >/dev/null 2>&1");
}

#----------------------------------------------------------
sub checkAI
#----------------------------------------------------------
{
  chop($nowdate = `date +%Y/%m/%d`);
  chop($nowhour = `date +%H`);
  ##chop($nowday  = `date +%a`);

  $inhibdir  = "/opt/dbamon/adm/inhibit";
  $inhibfile = "${in_hostname}_$in_instance";

  #
  # Check SERVER-INSTANCE inhibit file
  #

  print "$P | Checking $inhibdir/$inhibfile for outage now\n";

  if (-e "$inhibdir/$inhibfile")
  {
    if (system("grep 'Date=$nowdate Hour=$nowhour' $inhibdir/$inhibfile 2>&1") == 0)
    {
      print "$P | INSTANCE_INIBITED\n";
    }
  }

  #
  # Check SERVER inhibit file
  #

  print "$P | Checking $inhibdir/$in_fqhost for outage now\n";
  if (-e "$inhibdir/$in_fqhost")
  {
    if (system("grep 'Date=$nowdate Hour=$nowhour' $inhibdir/$in_fqhost 2>&1") == 0)
    {
      print "$P | SERVER_INIBITED\n";
    }
  }
}

#----------------------------------------------------------
sub checkBKP
#----------------------------------------------------------
{
  chop($nowdate = `date +%Y/%m/%d`);
  chop($nowhour = `date +%H`);
  ##chop($nowday  = `date +%a`);

  $inhibdir  = "/opt/dbamon/adm/inhibit";
  $inhibfile = "BKPSERVER_${in_bkpserver}.txt";
  &msgText("checkBKP - Checking inhibit file $inhibdir/$inhibfile for Date=$nowdate Hour=$nowhour"); 
  system("ll $inhibdir/$inhibfile 2>&1"); 

  #
  # Check SERVER-INSTANCE inhibit file
  #

  if (-e "$inhibdir/$inhibfile")
  {
    if (system("grep 'Date=$nowdate Hour=$nowhour' $inhibdir/$inhibfile 2>&1") == 0)
    {
      print "$P | BKPSERVER_INHIBITED\n";
    }
  }
  &msgText("checkBKP - Done"); 
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

$| = 1;

#---- Connect to DB
&connectDB;

#---- Parse arguments
$in_verb      = (split('\,',$ARGV[0])) [0];
$in_instance  = (split('\,',$ARGV[0])) [1];
$in_event     = (split('\,',$ARGV[0])) [2];

$in_event = "?" if ! $in_event;
  
&header("Event Snooze - Event: $in_event Instance: $in_instance"); 

#---- Get form data
&get_request;
$opcode        = $rqpairs{'opcode'};
$form_instance = $rqpairs{'form_instance'};
$form_event    = $rqpairs{'form_event'};

&msg("DEBUG: Starting - in_verb=$in_verb in_instance=$in_instance - form_instance=$form_instance form_event=$form_event opcode=$opcode") if $debug; 

&msg("This transaction allows you to Snooze a DBAmon Event for a DBAmon-monitored Instance"); 

if ($form_instance ne "")  #---- Are we processing the form? 
{
  if ($opcode eq "delete")
  {
    &deleteData;
  }

  if ($opcode eq "insert")
  {
    &error_check;

    if (@error_list != 0)
    {
      print LOG "Encountered errors\n";
      &error_html;
      exit 1;
    }

    print LOG "No errors\n";

    &deleteData;
    &insertData;
  }

  $goback = "-2";
  print "<script language='JavaScript'> function back() { history.go($goback); } </script>";
  print "<p><hr>$fs<b>To return to the Event Detail Page, \n";
  print "<a href='javascript:back()'>Click Here</a>";

  close(LOG);
  exit 0;
}

#---- Read data in table for this instance
if ($in_event ne "" && $in_event ne "?") 
{
  &selectData;
}
else
{
  &selectDataAllEvents;
  &msg("Done - Select an Event to Edit or Click Back to Return.");
  exit;
}

#---- Init data values
&init_values;

#---- Print finished form
&create_form;

close(LOG);
exit 0;
