#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_tasks - Display prod task status
# =========================================================

$P = "dbamon_event_purge.pl";
$| = 1;
$threshold = 600; # Was 900
$debug = 1;
chop($hostname = `hostname`);

$verb = $ARGV[0];

# Set PATH
# Make sure that /opt/socks/bin/ is in PATH
$old_path             = $ENV{"PATH"};
$ENV{'PATH'}          = "/opt/socks/bin:/opt/dbamon/bin:${old_path}";
$os = $ENV{"ORACLE_SID"};

# =========================================================
# Subroutines
# =========================================================

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $errmsg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $errmsg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  $e_time = time - $g_stime;
  system("echo 'e_time=$e_time' | mailx -m -s '$P - $errmsg' border\@dba.it.thecompany.com");
  exit 1;
}

# =========================================================
sub msg
# =========================================================
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

# =========================================================
sub connectDB
# =========================================================
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) || &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

# =========================================================
sub queryTableAge
# =========================================================
{
  &msg("Querying age of oldest row in DBAMON.EVENTS");
  my $age = -1;

  $sql  = " select sysdate - min(ts) from dbamon.events";
  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  while (@Data = $sth->fetchrow_array)
  {
    $age= $Data[0];
  }
  return $age;
}

# =========================================================
sub countEventRows
# =========================================================
{
  &msg("Counting rows in DBAMON.EVENTS");
  my $count = -1;

  $sql  = " select count(*) from dbamon.events";
  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  while (@Data = $sth->fetchrow_array)
  {
    $count= $Data[0];
  }
  return $count;
}
 
# =========================================================
sub taskIter
# =========================================================
{
  ##&msg("Setting DB Env.");
  chop($ENV{"ORACLE_SID"} = `grep ORACLE_SID: /opt/dbamon/adm/dbamonrc$modesuf  | grep -v '^#' | awk '{ print \$2 }'`);
  chop($ENV{"ORACLE_HOME"} = `grep ^$ENV{"ORACLE_SID"}: /etc/oratab | awk -F: '{ print \$2 }'`);
  $ENV{"PATH"} = "$ENV{'ORACLE_HOME'}/bin:/opt/dbamon/bin:$ENV{'PATH'}";
  ##system("env | egrep 'ORA|PATH'");

  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;


  $var = "This is a test";


  $dbh->do("alter session set zsql_trace=true");

  exit;
  $dbh->do("begin work;");


  $statement = "insert into billtest (col1) values (?)";

  print "statement=$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');

  $sth->bind_param(1, $var);
 
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;

  exit;
  &msg("PROD Tasks");
  print "\n";
  print "         Last     Average  Average           \n";
  print "         Iter     Iter     Instance           \n";
  print "Mode     Complete Duration Count    Servers              \n";
  print "-------- -------- -------- -------- --------------------\n";
  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $i_alph= $Data[1];
    $i_num = $Data[2];
    $i_dur = int($Data[3] / 60);
    $i_min = int($Data[4] / 60);
    $i_max = int($Data[5] / 60);
    $num   = sprintf("%7.1f",$Data[6]);
    $avgper= sprintf("%7.2f",$i_dur/$num);

    #printf "%-8s %-26s %6s %6s 5>$i_dur <td align=right><h5>$i_min<td align
    #       $i_mode, $i_alph, $i_num, $i_dur <td align=right><h5>$i_dur <td align=right><h5>$i_min<td align
    #=right><h5>$i_max <td align=right><h5>$num <td align=right><h5>$avgper \n";
    printf "%-8s %8s %8s %8s %8s %-20s \n",
           $i_mode, $i_num, $i_dur, $num, $i_alph ;
    $taskcount++ if $i_mode =~ /^prod/;
    $taskzero++  if $i_mode =~ /^prod/ && $i_num == 0;
    $num_instances += $num;
  }
  print "\n";
  &msg("Total PROD Tasks:                $taskcount");
  &msg("PROD Tasks Still on Iter=0:      $taskzero");
  $z = int((($taskcount - $taskzero) / $taskcount) * 100);
  &msg("Percent of PROD Tasks on Iter>0: $z");
  print "\n";
}

sub tasks
# =========================================================
{
  $file = "/opt/dbamon/adm/processes_prod.txt";
  open(TASKS, "$file") || die "can't open $file - $!";
  while(<TASKS>)
  {
    @words = split;
    $pid     = $words[0];
    $task    = $words[1];
    $sts     = $words[2];
    $ststext = $words[3];
    $servers = $words[4];

    &msg("====================================================================");
    &msg("Mode: PROD Task: $task (pid=$pid servers=$servers)");
    $rc = system("ps -ef | grep ' $pid ' | grep -v grep | sort"); 
    &msg("====================================================================\n");
  }
  close(TASKS);
  $file = "/opt/dbamon/adm/processes_test.txt";
  open(TASKS, "$file") || die "can't open $file - $!";
  while(<TASKS>)
  {
    @words = split;
    $pid     = $words[0];
    $task    = $words[1];
    $sts     = $words[2];
    $ststext = $words[3];
    $servers = $words[4];

    &msg("====================================================================");
    &msg("Mode: TEST Task: $task (pid=$pid servers=$servers)");
    $rc = system("ps -ef | grep $pid | grep -v grep | sort"); 
    &msg("====================================================================\n");
  }
  close(TASKS);
}

# =========================================================
# Main
# =========================================================

&msg("Starting");

&connectDB;

$rows_before = &countEventRows;
&msg("DBAMON.EVENTS 'Before' Row Count: $rows_before");
  
$age_before = &queryTableAge;
&msg("DBAMON.EVENTS 'Before' Row Age: $age_before");
  
&msg("Done");
exit;




#drop table dbamon.temp_instances;
#
#create table dbamon.temp_instances as select 
#    e.instance, 
#    max(e.ts) ts,
#    count(all ts) count
#  from 
#    dbamon.events e
#  where
#    e.instance not in (select i.instance from dbamon.instances i)
#  group by
#    e.instance;
#
#
#select  
#  * 
#from 
#  dbamon.temp_instances
#where
#  ts < (sysdate - 180);
#
#select
#  sum(count)
#from 
#  dbamon.temp_instances
#where
#  ts < (sysdate - 180);
#
#select count(*) from dbamon.events;
#
#drop table dbamon.temp_instances;
#  
##exit;
